<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/object-0.29.0/src/read/pe/data_directory.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>data_directory.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../../storage.js"></script><script defer src="../../../../source-script.js"></script><script defer src="../../../../source-files.js"></script><script defer src="../../../../main.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../../object/index.html"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::slice</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::read</span>::{<span class="ident">Error</span>, <span class="ident">ReadError</span>, <span class="ident">ReadRef</span>, <span class="prelude-ty">Result</span>};
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">pe</span>, <span class="ident">LittleEndian</span> <span class="kw">as</span> <span class="ident">LE</span>};

<span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">ExportTable</span>, <span class="ident">ImportTable</span>, <span class="ident">RelocationBlockIterator</span>, <span class="ident">ResourceDirectory</span>, <span class="ident">SectionTable</span>};

<span class="doccomment">/// The table of data directories in a PE file.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DataDirectories</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="ident">entries</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">pe::ImageDataDirectory</span>],
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">DataDirectories</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Parse the data directory table.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// `data` must be the remaining optional data following the</span>
    <span class="doccomment">/// [optional header](pe::ImageOptionalHeader64).  `number` must be from the</span>
    <span class="doccomment">/// [`number_of_rva_and_sizes`](pe::ImageOptionalHeader64::number_of_rva_and_sizes)</span>
    <span class="doccomment">/// field of the optional header.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse</span>(<span class="ident">data</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>], <span class="ident">number</span>: <span class="ident">u32</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">entries</span> <span class="op">=</span> <span class="ident">data</span>
            .<span class="ident">read_slice_at</span>(<span class="number">0</span>, <span class="ident">number</span> <span class="kw">as</span> <span class="ident">usize</span>)
            .<span class="ident">read_error</span>(<span class="string">&quot;Invalid PE number of RVA and sizes&quot;</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="ident">DataDirectories</span> { <span class="ident">entries</span> })
    }

    <span class="doccomment">/// The number of data directories.</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::len_without_is_empty</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">entries</span>.<span class="ident">len</span>()
    }

    <span class="doccomment">/// Iterator over the data directories.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">iter</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">slice::Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">pe::ImageDataDirectory</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">entries</span>.<span class="ident">iter</span>()
    }

    <span class="doccomment">/// Iterator which gives the directories as well as their index (one of the IMAGE_DIRECTORY_ENTRY_* constants).</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">enumerate</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">core::iter::Enumerate</span><span class="op">&lt;</span><span class="ident">slice::Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">pe::ImageDataDirectory</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">entries</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>()
    }

    <span class="doccomment">/// Returns the data directory at the given index.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Index should be one of the `IMAGE_DIRECTORY_ENTRY_*` constants.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns `None` if the index is larger than the table size,</span>
    <span class="doccomment">/// or if the entry at the index has a zero virtual address.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">index</span>: <span class="ident">usize</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">pe::ImageDataDirectory</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">entries</span>
            .<span class="ident">get</span>(<span class="ident">index</span>)
            .<span class="ident">filter</span>(<span class="op">|</span><span class="ident">d</span><span class="op">|</span> <span class="ident">d</span>.<span class="ident">virtual_address</span>.<span class="ident">get</span>(<span class="ident">LE</span>) <span class="op">!</span><span class="op">=</span> <span class="number">0</span>)
    }

    <span class="doccomment">/// Returns the unparsed export directory.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// `data` must be the entire file data.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">export_directory</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
        <span class="ident">sections</span>: <span class="kw-2">&amp;</span><span class="ident">SectionTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">pe::ImageExportDirectory</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">data_dir</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">get</span>(<span class="ident">pe::IMAGE_DIRECTORY_ENTRY_EXPORT</span>) {
            <span class="prelude-val">Some</span>(<span class="ident">data_dir</span>) =&gt; <span class="ident">data_dir</span>,
            <span class="prelude-val">None</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>),
        };
        <span class="kw">let</span> <span class="ident">export_data</span> <span class="op">=</span> <span class="ident">data_dir</span>.<span class="ident">data</span>(<span class="ident">data</span>, <span class="ident">sections</span>)<span class="question-mark">?</span>;
        <span class="ident">ExportTable::parse_directory</span>(<span class="ident">export_data</span>).<span class="ident">map</span>(<span class="prelude-val">Some</span>)
    }

    <span class="doccomment">/// Returns the partially parsed export directory.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// `data` must be the entire file data.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">export_table</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
        <span class="ident">sections</span>: <span class="kw-2">&amp;</span><span class="ident">SectionTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">ExportTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">data_dir</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">get</span>(<span class="ident">pe::IMAGE_DIRECTORY_ENTRY_EXPORT</span>) {
            <span class="prelude-val">Some</span>(<span class="ident">data_dir</span>) =&gt; <span class="ident">data_dir</span>,
            <span class="prelude-val">None</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>),
        };
        <span class="kw">let</span> <span class="ident">export_va</span> <span class="op">=</span> <span class="ident">data_dir</span>.<span class="ident">virtual_address</span>.<span class="ident">get</span>(<span class="ident">LE</span>);
        <span class="kw">let</span> <span class="ident">export_data</span> <span class="op">=</span> <span class="ident">data_dir</span>.<span class="ident">data</span>(<span class="ident">data</span>, <span class="ident">sections</span>)<span class="question-mark">?</span>;
        <span class="ident">ExportTable::parse</span>(<span class="ident">export_data</span>, <span class="ident">export_va</span>).<span class="ident">map</span>(<span class="prelude-val">Some</span>)
    }

    <span class="doccomment">/// Returns the partially parsed import directory.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// `data` must be the entire file data.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">import_table</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
        <span class="ident">sections</span>: <span class="kw-2">&amp;</span><span class="ident">SectionTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">ImportTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">data_dir</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">get</span>(<span class="ident">pe::IMAGE_DIRECTORY_ENTRY_IMPORT</span>) {
            <span class="prelude-val">Some</span>(<span class="ident">data_dir</span>) =&gt; <span class="ident">data_dir</span>,
            <span class="prelude-val">None</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>),
        };
        <span class="kw">let</span> <span class="ident">import_va</span> <span class="op">=</span> <span class="ident">data_dir</span>.<span class="ident">virtual_address</span>.<span class="ident">get</span>(<span class="ident">LE</span>);
        <span class="kw">let</span> (<span class="ident">section_data</span>, <span class="ident">section_va</span>) <span class="op">=</span> <span class="ident">sections</span>
            .<span class="ident">pe_data_containing</span>(<span class="ident">data</span>, <span class="ident">import_va</span>)
            .<span class="ident">read_error</span>(<span class="string">&quot;Invalid import data dir virtual address&quot;</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="ident">ImportTable::new</span>(<span class="ident">section_data</span>, <span class="ident">section_va</span>, <span class="ident">import_va</span>)))
    }

    <span class="doccomment">/// Returns the blocks in the base relocation directory.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// `data` must be the entire file data.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">relocation_blocks</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
        <span class="ident">sections</span>: <span class="kw-2">&amp;</span><span class="ident">SectionTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">RelocationBlockIterator</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">data_dir</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">get</span>(<span class="ident">pe::IMAGE_DIRECTORY_ENTRY_BASERELOC</span>) {
            <span class="prelude-val">Some</span>(<span class="ident">data_dir</span>) =&gt; <span class="ident">data_dir</span>,
            <span class="prelude-val">None</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>),
        };
        <span class="kw">let</span> <span class="ident">reloc_data</span> <span class="op">=</span> <span class="ident">data_dir</span>.<span class="ident">data</span>(<span class="ident">data</span>, <span class="ident">sections</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="ident">RelocationBlockIterator::new</span>(<span class="ident">reloc_data</span>)))
    }

    <span class="doccomment">/// Returns the resource directory.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// `data` must be the entire file data.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">resource_directory</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
        <span class="ident">sections</span>: <span class="kw-2">&amp;</span><span class="ident">SectionTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">ResourceDirectory</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">data_dir</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">get</span>(<span class="ident">pe::IMAGE_DIRECTORY_ENTRY_RESOURCE</span>) {
            <span class="prelude-val">Some</span>(<span class="ident">data_dir</span>) =&gt; <span class="ident">data_dir</span>,
            <span class="prelude-val">None</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>),
        };
        <span class="kw">let</span> <span class="ident">rsrc_data</span> <span class="op">=</span> <span class="ident">data_dir</span>.<span class="ident">data</span>(<span class="ident">data</span>, <span class="ident">sections</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="ident">ResourceDirectory::new</span>(<span class="ident">rsrc_data</span>)))
    }
}

<span class="kw">impl</span> <span class="ident">pe::ImageDataDirectory</span> {
    <span class="doccomment">/// Return the virtual address range of this directory entry.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">address_range</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; (<span class="ident">u32</span>, <span class="ident">u32</span>) {
        (<span class="self">self</span>.<span class="ident">virtual_address</span>.<span class="ident">get</span>(<span class="ident">LE</span>), <span class="self">self</span>.<span class="ident">size</span>.<span class="ident">get</span>(<span class="ident">LE</span>))
    }

    <span class="doccomment">/// Return the file offset and size of this directory entry.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This function has some limitations:</span>
    <span class="doccomment">/// - It requires that the data is contained in a single section.</span>
    <span class="doccomment">/// - It uses the size field of the directory entry, which is</span>
    <span class="doccomment">/// not desirable for all data directories.</span>
    <span class="doccomment">/// - It uses the `virtual_address` of the directory entry as an address,</span>
    <span class="doccomment">/// which is not valid for `IMAGE_DIRECTORY_ENTRY_SECURITY`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">file_range</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">sections</span>: <span class="kw-2">&amp;</span><span class="ident">SectionTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(<span class="ident">u32</span>, <span class="ident">u32</span>)<span class="op">&gt;</span> {
        <span class="kw">let</span> (<span class="ident">offset</span>, <span class="ident">section_size</span>) <span class="op">=</span> <span class="ident">sections</span>
            .<span class="ident">pe_file_range_at</span>(<span class="self">self</span>.<span class="ident">virtual_address</span>.<span class="ident">get</span>(<span class="ident">LE</span>))
            .<span class="ident">read_error</span>(<span class="string">&quot;Invalid data dir virtual address&quot;</span>)<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">size</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">size</span>.<span class="ident">get</span>(<span class="ident">LE</span>);
        <span class="kw">if</span> <span class="ident">size</span> <span class="op">&gt;</span> <span class="ident">section_size</span> {
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error</span>(<span class="string">&quot;Invalid data dir size&quot;</span>));
        }
        <span class="prelude-val">Ok</span>((<span class="ident">offset</span>, <span class="ident">size</span>))
    }

    <span class="doccomment">/// Get the data referenced by this directory entry.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This function has some limitations:</span>
    <span class="doccomment">/// - It requires that the data is contained in a single section.</span>
    <span class="doccomment">/// - It uses the size field of the directory entry, which is</span>
    <span class="doccomment">/// not desirable for all data directories.</span>
    <span class="doccomment">/// - It uses the `virtual_address` of the directory entry as an address,</span>
    <span class="doccomment">/// which is not valid for `IMAGE_DIRECTORY_ENTRY_SECURITY`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">data</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">data</span>: <span class="ident">R</span>,
        <span class="ident">sections</span>: <span class="kw-2">&amp;</span><span class="ident">SectionTable</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> {
        <span class="ident">sections</span>
            .<span class="ident">pe_data_at</span>(<span class="ident">data</span>, <span class="self">self</span>.<span class="ident">virtual_address</span>.<span class="ident">get</span>(<span class="ident">LE</span>))
            .<span class="ident">read_error</span>(<span class="string">&quot;Invalid data dir virtual address&quot;</span>)<span class="question-mark">?</span>
            .<span class="ident">get</span>(..<span class="self">self</span>.<span class="ident">size</span>.<span class="ident">get</span>(<span class="ident">LE</span>) <span class="kw">as</span> <span class="ident">usize</span>)
            .<span class="ident">read_error</span>(<span class="string">&quot;Invalid data dir size&quot;</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="object" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>